// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Observer.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package IceGrid;

/**
 * This interface allows applications to monitor changes the state
 * of the registry.
 * 
 **/
public final class RegistryObserverPrxHelper extends Ice.ObjectPrxHelperBase implements RegistryObserverPrx
{
    private static final String __registryDown_name = "registryDown";

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param name The node name.
     * 
     **/
    public void registryDown(String name)
    {
        registryDown(name, null, false);
    }

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param name The node name.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void registryDown(String name, java.util.Map<String, String> __ctx)
    {
        registryDown(name, __ctx, true);
    }

    private void registryDown(String name, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "registryDown", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _RegistryObserverDel __del = (_RegistryObserverDel)__delBase;
                    __del.registryDown(name, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param __cb The callback object for the operation.
     * @param name The node name.
     * 
     **/
    public Ice.AsyncResult begin_registryDown(String name)
    {
        return begin_registryDown(name, null, false, null);
    }

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param __cb The callback object for the operation.
     * @param name The node name.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_registryDown(String name, java.util.Map<String, String> __ctx)
    {
        return begin_registryDown(name, __ctx, true, null);
    }

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param __cb The callback object for the operation.
     * @param name The node name.
     * 
     **/
    public Ice.AsyncResult begin_registryDown(String name, Ice.Callback __cb)
    {
        return begin_registryDown(name, null, false, __cb);
    }

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param __cb The callback object for the operation.
     * @param name The node name.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_registryDown(String name, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_registryDown(name, __ctx, true, __cb);
    }

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param __cb The callback object for the operation.
     * @param name The node name.
     * 
     **/
    public Ice.AsyncResult begin_registryDown(String name, Callback_RegistryObserver_registryDown __cb)
    {
        return begin_registryDown(name, null, false, __cb);
    }

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param __cb The callback object for the operation.
     * @param name The node name.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_registryDown(String name, java.util.Map<String, String> __ctx, Callback_RegistryObserver_registryDown __cb)
    {
        return begin_registryDown(name, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_registryDown(String name, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __registryDown_name, __cb);
        try
        {
            __result.__prepare(__registryDown_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(name);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_registryDown(Ice.AsyncResult __result)
    {
        __end(__result, __registryDown_name);
    }

    private static final String __registryInit_name = "registryInit";

    /**
     * The <tt>registryInit</tt> operation is called after registration of
     * an observer to indicate the state of the registries.
     * 
     * @param registries The current state of the registries.
     * 
     **/
    public void registryInit(RegistryInfo[] registries)
    {
        registryInit(registries, null, false);
    }

    /**
     * The <tt>registryInit</tt> operation is called after registration of
     * an observer to indicate the state of the registries.
     * 
     * @param registries The current state of the registries.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void registryInit(RegistryInfo[] registries, java.util.Map<String, String> __ctx)
    {
        registryInit(registries, __ctx, true);
    }

    private void registryInit(RegistryInfo[] registries, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "registryInit", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _RegistryObserverDel __del = (_RegistryObserverDel)__delBase;
                    __del.registryInit(registries, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * The <tt>registryInit</tt> operation is called after registration of
     * an observer to indicate the state of the registries.
     * 
     * @param __cb The callback object for the operation.
     * @param registries The current state of the registries.
     * 
     **/
    public Ice.AsyncResult begin_registryInit(RegistryInfo[] registries)
    {
        return begin_registryInit(registries, null, false, null);
    }

    /**
     * The <tt>registryInit</tt> operation is called after registration of
     * an observer to indicate the state of the registries.
     * 
     * @param __cb The callback object for the operation.
     * @param registries The current state of the registries.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_registryInit(RegistryInfo[] registries, java.util.Map<String, String> __ctx)
    {
        return begin_registryInit(registries, __ctx, true, null);
    }

    /**
     * The <tt>registryInit</tt> operation is called after registration of
     * an observer to indicate the state of the registries.
     * 
     * @param __cb The callback object for the operation.
     * @param registries The current state of the registries.
     * 
     **/
    public Ice.AsyncResult begin_registryInit(RegistryInfo[] registries, Ice.Callback __cb)
    {
        return begin_registryInit(registries, null, false, __cb);
    }

    /**
     * The <tt>registryInit</tt> operation is called after registration of
     * an observer to indicate the state of the registries.
     * 
     * @param __cb The callback object for the operation.
     * @param registries The current state of the registries.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_registryInit(RegistryInfo[] registries, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_registryInit(registries, __ctx, true, __cb);
    }

    /**
     * The <tt>registryInit</tt> operation is called after registration of
     * an observer to indicate the state of the registries.
     * 
     * @param __cb The callback object for the operation.
     * @param registries The current state of the registries.
     * 
     **/
    public Ice.AsyncResult begin_registryInit(RegistryInfo[] registries, Callback_RegistryObserver_registryInit __cb)
    {
        return begin_registryInit(registries, null, false, __cb);
    }

    /**
     * The <tt>registryInit</tt> operation is called after registration of
     * an observer to indicate the state of the registries.
     * 
     * @param __cb The callback object for the operation.
     * @param registries The current state of the registries.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_registryInit(RegistryInfo[] registries, java.util.Map<String, String> __ctx, Callback_RegistryObserver_registryInit __cb)
    {
        return begin_registryInit(registries, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_registryInit(RegistryInfo[] registries, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __registryInit_name, __cb);
        try
        {
            __result.__prepare(__registryInit_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            RegistryInfoSeqHelper.write(__os, registries);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_registryInit(Ice.AsyncResult __result)
    {
        __end(__result, __registryInit_name);
    }

    private static final String __registryUp_name = "registryUp";

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param node The node state.
     * 
     **/
    public void registryUp(RegistryInfo node)
    {
        registryUp(node, null, false);
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param node The node state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void registryUp(RegistryInfo node, java.util.Map<String, String> __ctx)
    {
        registryUp(node, __ctx, true);
    }

    private void registryUp(RegistryInfo node, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "registryUp", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _RegistryObserverDel __del = (_RegistryObserverDel)__delBase;
                    __del.registryUp(node, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node state.
     * 
     **/
    public Ice.AsyncResult begin_registryUp(RegistryInfo node)
    {
        return begin_registryUp(node, null, false, null);
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_registryUp(RegistryInfo node, java.util.Map<String, String> __ctx)
    {
        return begin_registryUp(node, __ctx, true, null);
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node state.
     * 
     **/
    public Ice.AsyncResult begin_registryUp(RegistryInfo node, Ice.Callback __cb)
    {
        return begin_registryUp(node, null, false, __cb);
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_registryUp(RegistryInfo node, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_registryUp(node, __ctx, true, __cb);
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node state.
     * 
     **/
    public Ice.AsyncResult begin_registryUp(RegistryInfo node, Callback_RegistryObserver_registryUp __cb)
    {
        return begin_registryUp(node, null, false, __cb);
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_registryUp(RegistryInfo node, java.util.Map<String, String> __ctx, Callback_RegistryObserver_registryUp __cb)
    {
        return begin_registryUp(node, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_registryUp(RegistryInfo node, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __registryUp_name, __cb);
        try
        {
            __result.__prepare(__registryUp_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            node.__write(__os);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_registryUp(Ice.AsyncResult __result)
    {
        __end(__result, __registryUp_name);
    }

    public static RegistryObserverPrx checkedCast(Ice.ObjectPrx __obj)
    {
        RegistryObserverPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof RegistryObserverPrx)
            {
                __d = (RegistryObserverPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    RegistryObserverPrxHelper __h = new RegistryObserverPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static RegistryObserverPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        RegistryObserverPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof RegistryObserverPrx)
            {
                __d = (RegistryObserverPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    RegistryObserverPrxHelper __h = new RegistryObserverPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static RegistryObserverPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        RegistryObserverPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    RegistryObserverPrxHelper __h = new RegistryObserverPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static RegistryObserverPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        RegistryObserverPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    RegistryObserverPrxHelper __h = new RegistryObserverPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static RegistryObserverPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        RegistryObserverPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof RegistryObserverPrx)
            {
                __d = (RegistryObserverPrx)__obj;
            }
            else
            {
                RegistryObserverPrxHelper __h = new RegistryObserverPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static RegistryObserverPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        RegistryObserverPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            RegistryObserverPrxHelper __h = new RegistryObserverPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::IceGrid::RegistryObserver"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _RegistryObserverDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _RegistryObserverDelD();
    }

    public static void __write(IceInternal.BasicStream __os, RegistryObserverPrx v)
    {
        __os.writeProxy(v);
    }

    public static RegistryObserverPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            RegistryObserverPrxHelper result = new RegistryObserverPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
